/**************************************************************************/
/*                                                                        */
/*                                 BOO                                    */
/*                                 ===                                    */
/*                                                                        */
/*             Programmet som frenklar ett booleskt uttryck.             */
/*                                                                        */
/*                                  av                                    */
/*                                                                        */
/*                    Mikael Swahn och Bjrn Elenfors                     */
/*                                                                        */
/*                                 1991                                   */
/*                                                                        */
/*          (c) Copyright 1991 Mikael Swahn och Bjrn Elenfors            */
/*                                                                        */
/**************************************************************************/

/******************************************************/
/* Include filer                                      */
/*                                                    */
/* stdio.h  - IO variabler.                           */
/* string.h - strnghantering, i detta falt strlen(). */
/******************************************************/

#include <string.h>
#include <stdio.h>

/**************/
/* Funktioner */
/**************/

char ROL(),ROR(),NRB(),FBNR();

/****************************************************/
/*  Loop- och temporra varibler.                   */
/*  i,j,k,l,m,n,p,q,r,w,temp1,temp2,temp3           */
/****************************************************/
/* antalor   - Antal OR i det inmatade uttrycket.   */
/* antal     - Antal OR+1 i det slutliga uttrycket. */
/* noll      - r 1 om slutliga uttrycket blir noll */
/* inm[]     - Inmatningsbuffer.                    */
/* Y1[][]    - Bokstverna i det inmatade uttrycket */
/*             omvandlade till siffror.             */
/* Y2[][]    - Alla kombinationer som finns, de     */
/*             ondiga nollstlls sedan.            */
/****************************************************/

char Y1[260][2],Y2[90][3],inm[512],c;
int i,j,k,l,m,n,p,q,r,w,temp1,temp2,temp3,noll,antalor,antal;

main()
{
 while(inm[0]!='q' && inm[0]!='Q')
 {
  /*******************************/
  /* Utskrift av programnamn mm. */
  /*******************************/

  printf("\14\n                                   B O O\n");
  printf("                                   =====\n\n\n");
  printf("                                    av\n\n");
  printf("                               Mikael Swahn\n\n");
  printf("                                    och\n\n");
  printf("                              Bjrn Elenfors\n\n\n");
  printf("                           Skriv \"Q\" fr att sluta\n\n\n\n");
  printf("  Mata in ditt booleska uttryck : ");

  /***********************************/
  /* Inmatning till bufferten inm[]. */
  /***********************************/

  scanf("%s",inm);

  /*********************************************************/
  /* Om "Q" eller "q" matas in s ska programmet avslutas. */
  /*********************************************************/

  if(inm[0]!='q' && inm[0]!='Q')
  {

   /*****************************************/
   /* Rensar variablerna Y1[][] och Y2[][]. */
   /*****************************************/

   for(i=0;i<260;i++)
   {
    Y1[i][0]=15;
    Y1[i][1]=15;
   }
   for(i=0;i<89;i++)
   {
    Y2[i][0]=0;
    Y2[i][1]=0;
    Y2[i][2]=0;
   }

   /*****************************************************************/
   /* Konverterar de inmatade bokstverna till rader och kolumner.  */
   /* Y1[][0] innehller radnr. och Y1[][1] innheller kolumnnr.    */
   /* Hr nedan visas vad varje rad och kolumn har fr nr.          */
   /*                                                               */
   /*                        1   2   4   8                          */
   /*                        A   A   a   a                          */
   /*                      =================                        */
   /*                  1 B =   =   =   =   = c                      */
   /*                      =================                        */
   /*                  2 B =   =   =   =   = C                      */
   /*                      =================                        */
   /*                  4 b =   =   =   =   = C                      */
   /*                      =================                        */
   /*                  8 b =   =   =   =   = c                      */
   /*                      =================                        */
   /*                        d   D   D   d                          */
   /*                                                               */
   /*****************************************************************/

   noll=0;
   antalor=0;
   for(i=0;i<strlen(inm);i++)
   {
    if(inm[i]=='+') antalor++;
    switch(inm[i])
    {
     case 'A':Y1[antalor][1]=Y1[antalor][1]&3;break;
     case 'B':Y1[antalor][0]=Y1[antalor][0]&3;break;
     case 'C':Y1[antalor][0]=Y1[antalor][0]&6;break;
     case 'D':Y1[antalor][1]=Y1[antalor][1]&6;break;
     case 'a':Y1[antalor][1]=Y1[antalor][1]&12;break;
     case 'b':Y1[antalor][0]=Y1[antalor][0]&12;break;
     case 'c':Y1[antalor][0]=Y1[antalor][0]&9;break;
     case 'd':Y1[antalor][1]=Y1[antalor][1]&9;break;
    }
    if(Y1[antalor][0]==0 || Y1[antalor][1]==0) noll=1;
   }

   /***********************************************************************/
   /* Delar upp alla uttryck i Y1[][] i mindre uttryck s att varje       */
   /* uttryck endast innehller en ruta. Resultatet lggs i Y2[][].       */
   /* Det gr till s att frsta satta biten vljs i Y1[][0] och Y1[][1]  */
   /* dessa bildar ett uttryck. Innan det sparas i Y2[][] s kollas om    */
   /* uttrycket redan finns i Y2[][], om s r fallet sparas uttrycket    */
   /* inte. Sedan fortstter man med nsta bit och nr de satta bitarna   */
   /* r slut s fortstter man med nsta uttryck.                        */
   /***********************************************************************/

   if(noll==0)
   {
    antal=0;
    for(l=0;l<=antalor;l++)
    {
     for(j=1;j<5;j++)
     {
      if(m=FBNR(Y1[l][0],j))
      {
       for(k=1;k<5;k++)
       {
        if(n=FBNR(Y1[l][1],k))
        {
         temp1=0;
         for(p=0;p<antal;p++) if((Y2[p][0]==m) && (Y2[p][1]==n)) temp1=1;
         if(temp1==0)
         {
          Y2[antal][0]=m;
          Y2[antal][1]=n;
          antal++;
         }
        }
       }
      }
     }
    }

    /***********************************************************************/
    /* Kombinerar de rutor i Y2[][] som ligger bredvid varandra s att det */
    /* bildas uttryck som innehller 2 rutor sedan kombinerar man dessa    */
    /* och fr d ngra uttryck som innehller 4 rutor sedan fr man 8     */
    /* rutor och till slut 16 rutor.                                       */
    /***********************************************************************/

    temp2=0;
    for(i=0;i<4;i++)
    {
     temp1=temp2;
     temp2=antal;
     for(j=temp1;j<temp2;j++)
     {
      for(k=temp1;k<j;k++)
      {
       n=2;
       for(m=0;m<2;m++)
       {
        n--;
        temp3=(ROR(Y2[j][n],NRB(Y2[j][n]))&(Y2[k][n]));
        for(p=0;p<2;p++)
        {
         if(Y2[j][m]==Y2[k][m] && temp3 && NRB(Y2[j][n]|temp3)!=3)
         {
          Y2[antal][m]=Y2[j][m];
          Y2[antal][n]=Y2[j][n]|temp3;
          w=0;
          for(l=0;l<antal;l++)
          {
           if(Y2[antal][m]==Y2[l][m] && Y2[antal][n]==Y2[l][n]) w=1;
          }
          if(w==0) antal++;
         }
         temp3=(ROL(Y2[j][n],NRB(Y2[j][n]))&(Y2[k][n]));
        }
       }
      }
     }
    }
 
    /***********************************************************************/
    /* Kollar sedan vilka uttryck som kan tas bort. Man brjar med de      */
    /* uttryck som innehller 1 ruta och kollar om de finns i ngot strre */
    /* uttryck (som innehller fler rutor). Om s r fallet raderas        */
    /* uttrycket. Sedan fortstter man med de uttrycken som har 2 rutor    */
    /* o.s.v. Om ett uttryck endast finns i uttryck som har lika mnga     */
    /* rutor som uttrycket sjlv s raderas uttrycket inte. uttrycket      */
    /* kanske frsvinner nsta gng allt kollas. Det beror p om de        */
    /* uttryck uttrycket fanns i, finns kvar andra gngen.                 */ 
    /***********************************************************************/
 
    for(w=0;w<2;w++)
    {
     for(i=1;i<17;i=i<<1)
     {
      for(l=0;l<antal;l++)
      {
       temp1=0;
       r=0;
       if((NRB(Y2[l][0])*NRB(Y2[l][1]))==i)
       {
        for(j=1;j<5;j++)
        {
         if(m=FBNR(Y2[l][0],j))
         {
          for(k=1;k<5;k++)
          {
           if(n=FBNR(Y2[l][1],k))
           {
            temp1++;
            for(q=16;q>0;q=q>>1)
            {
             for(p=0;p<antal;p++)
             {
              if(((NRB(Y2[p][0])*NRB(Y2[p][1]))==q) && (Y2[p][0]&m) && (Y2[p][1]&n) && p!=l)
              {
               if(q==i && Y2[l][2]!=2 && !w) Y2[l][2]=1;
               else Y2[l][2]=2;
               r++;
               p=antal;
               q=0;
              }
             }
            }
           }
          }
         }
        }
        if(temp1==r && Y2[l][2]!=1)
        {
         Y2[l][0]=0;
         Y2[l][1]=0;
        }
       }
      }
     }
    }
   }
 
   /***********************************************************************/
   /* Utskrift av det frdiga uttrycket. Man gr om rader och kolumner    */
   /* till bokstver.                                                     */
   /***********************************************************************/
   k=0;
   printf("  Det frenklade uttrycket blir : ");
   if(noll==0)
   {
    for(l=0;l<antal;l++)
    {
     if(Y2[l][0]==15) Y2[l][0]=0;
     if(Y2[l][1]==15) Y2[l][1]=0;
     if((Y2[l][1]&3) && !(Y2[l][1]&12)) {printf("A");k++;}
     if((Y2[l][1]&12) && !(Y2[l][1]&3)) {printf("a");k++;}
     if((Y2[l][0]&3) && !(Y2[l][0]&12)) {printf("B");k++;}
     if((Y2[l][0]&12) && !(Y2[l][0]&3)) {printf("b");k++;}
     if((Y2[l][0]&6) && !(Y2[l][0]&9)) {printf("C");k++;}
     if((Y2[l][0]&9) && !(Y2[l][0]&6)) {printf("c");k++;}
     if((Y2[l][1]&6) && !(Y2[l][1]&9)) {printf("D");k++;}
     if((Y2[l][1]&9) && !(Y2[l][1]&6)) {printf("d");k++;}
     if(l!=antal-1 && k!=0 && (Y2[l+1][0] || Y2[l+1][1])) printf("+");
    }
    if(k==0) printf("1");
   }
   else printf("0");
   printf("\n\n  Tryck RETURN fr att fortstta ");
   for(i=0;i<2;i++) c=getchar();
  }
 }
}

/**********************************************************************/
/* Roterar variablen X COUNT gnger t vnster och returnerar vrdet. */
/*                                                                    */
/* Ex. ROL(10,1)=5                                                    */
/**********************************************************************/

char ROL(char X,char COUNT)
{
 X=(((X=(X<<COUNT))|(X>>4))&15);
 return(X);
}

/********************************************************************/
/* Roterar variablen A COUNT gnger t hger och returnerar vrdet. */
/*                                                                  */
/* Ex. ROR(9,1)=12                                                  */
/********************************************************************/

char ROR(char X,char COUNT)
{
 X=(((X=X|(X<<4))>>COUNT)&15);
 return(X);
}

/**********************************************************************/
/* Tar reda p hur mnga bitar som r ettor i vrdet X och returnerar */
/* det                                                                */
/* i - loopvariabel                                                   */
/* M - antal bitar                                                    */
/*                                                                    */
/* Ex. NRB(9)=2                                                       */
/**********************************************************************/

char NRB(char X)
{

 char i,M=0;

 for(i=0;i<4;i++)
 {
  if((X&1)==1) M++;
  X=X>>1;
 }
 return(M);
}

/**********************************************************************/
/* Returnera vrdet d endast bit B som r etta i variabeln A anvnds */
/* i,j    - loopvariabler.                                            */
/* number - Vrdet som ska returneras.                                */
/*                                                                    */
/* Ex. FBNR(7,2)=2                                                    */
/*     FBNR(6,2)=4                                                    */
/**********************************************************************/

char FBNR(char A,char B)
{
 char i,j,number;

 number=1;
 for(i=0;i<B;i++)
 {
  for(j=0;j<5;j++)
  {
   if((number&A)) j=5;
   number=number<<1;
  }
 }
 number=number>>1;
 if(j==5) number=0;
 return(number);
}

/**********************************************************************/
